#import <AppKit/AppKit.h>
#import "SDMovingRowsProtocol.h"

@interface GifController : NSResponder <SDMovingRowsProtocol>
{
	id colorIndexField;
	id disposalMatrix;
	id loopField;
	id ouputDragWell;
	id statusField;
	id tableView;
	id loopMatrix;
	id window;
	id logText;

	NSMutableArray *gifFileArray;
	NSString *whirlgif;
	NSString *theDirectory;
	NSString *outputFile;
	id copiedRow;
}

//
// IB actions
//

//
// opening files
//
- (void)clearGifs:(id)sender;
- (void)openGifFolder:(id)sender;
- (void)addAnotherFile:(id)sender;
- (void)loadSample:(id)sender;

// 
// doing the great work
//
- (void)mergeGifs:(id)sender;
- (void)changeLoop:(id)sender;

//
// saving
//
- (void)saveGifAnimDirectory:(id)sender;
- (void)saveAs:(id)sender;
- (void)saveSettings:(id)sender;

//
// Covers for other nib files actions:
//
- (void)loadHelp:(id)sender;
- (void)loadWhirlGifHelp:(id)sender;
- (void)orderFrontInfo:(id)sender;
- (void)runDefaultsPanel:(id)sender;

- (void)loadDefaults;

//
// these are the workhorse methods that get called from 
// various entry points: services, open panel or drag & drop
//
- (int)tryAndLoadPath:(NSString *)path;	// either directory or gif file
- (int)loadGifsInDirectory:(NSString *)path;
- (int)addGifFile:(NSString *)aFile;
- (BOOL)isGifFile:(NSString *)path;

//
//  Preferences needs this:
//
- (NSString *)temporaryDirectory;

@end

