#import "SDMovingImageCell.h"

@implementation SDMovingImageCell

- initImageCell:(NSImage *)image owner:anOwner
{
	[super initImageCell:image];
	owner = anOwner;
  	return self;
}

+ (BOOL)prefersTrackingUntilMouseUp
{
	return YES;
}

- (void)orderFrontWindowWithImage:(NSImage *)image atPoint:(NSPoint)startPoint inView:(NSView *)controlView
{
	// get a new, borderless, titleless window
	// set the contentView of the window to an NSImageView with our image
	// order it front at converted point...
     NSRect cRect;
     NSRect iRect = NSZeroRect;
     NSImageView *iv;

     startPoint = [controlView convertPoint:startPoint toView:nil];
     startPoint = [[controlView window] convertBaseToScreen:startPoint];
     cRect.origin = startPoint;
     cRect.size = [image size];
     iRect.size = [image size];

     iv = [[NSImageView alloc] initWithFrame:iRect];
     [iv setImage:image];

     imageWindow = [[NSWindow alloc] initWithContentRect:cRect styleMask:NSBorderlessWindowMask
		backing:NSBackingStoreRetained defer:NO];
     [imageWindow setContentView:iv];
     [imageWindow setOneShot:YES];  // auto release on order out...
     [imageWindow orderFront:self];
    
}


- (BOOL)startTrackingAt:(NSPoint)startPoint inView:(NSView *)controlView
{
     startRow = [(NSTableView *)controlView rowAtPoint:startPoint];
    [self orderFrontWindowWithImage:[owner imageForRow:startRow] atPoint:startPoint inView:controlView];
    return YES;	// keep sending us events
}

- (BOOL)continueTracking:(NSPoint)lastPoint at:(NSPoint)currentPoint inView:(NSView *)controlView
{
        NSRect frame = [imageWindow frame];
	frame.origin.x += (currentPoint.x - lastPoint.x);
	frame.origin.y +=  (currentPoint.y - lastPoint.y);
	[imageWindow setFrameOrigin:frame.origin];
	return YES;
}

- (void)stopTracking:(NSPoint)lastPoint at:(NSPoint)stopPoint inView:(NSView *)controlView
	mouseIsUp:(BOOL)flag
{
     if (flag == YES) {
	[imageWindow orderOut:self];	// does it need to be released:look at creation methods
         [controlView startRow:startRow endedAt:(int)[controlView rowAtPoint:stopPoint]];
     }
}

@end
